/*
 * Generated by asn1c-0.9.29 (http://lionet.info/asn1c)
 * From ASN.1 module "Ieee1609Dot3Wee"
 * 	found in "../Ieee1609Dot3Wee.asn"
 * 	`asn1c -fcompound-names -gen-PER`
 */

#include "Extension.h"

static int
memb_extensionId_constraint_1(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	long value;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	value = *(const long *)sptr;
	
	if((value >= 0 && value <= 255)) {
		/* Constraint check succeeded */
		return 0;
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_value_constraint_1(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	if(1 /* No applicable constraints whatsoever */) {
		/* Nothing is here. See below */
	}
	
	return td->check_constraints(td, sptr, ctfailcb, app_key);
}

static int
memb_extensionId_constraint_4(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	long value;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	value = *(const long *)sptr;
	
	if((value >= 0 && value <= 255)) {
		/* Constraint check succeeded */
		return 0;
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_value_constraint_4(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	if(1 /* No applicable constraints whatsoever */) {
		/* Nothing is here. See below */
	}
	
	return td->check_constraints(td, sptr, ctfailcb, app_key);
}

static int
memb_extensionId_constraint_7(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	long value;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	value = *(const long *)sptr;
	
	if((value >= 0 && value <= 255)) {
		/* Constraint check succeeded */
		return 0;
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_value_constraint_7(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	if(1 /* No applicable constraints whatsoever */) {
		/* Nothing is here. See below */
	}
	
	return td->check_constraints(td, sptr, ctfailcb, app_key);
}

static int
memb_extensionId_constraint_10(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	long value;
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	value = *(const long *)sptr;
	
	if((value >= 0 && value <= 255)) {
		/* Constraint check succeeded */
		return 0;
	} else {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: constraint failed (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
}

static int
memb_value_constraint_10(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	
	if(!sptr) {
		ASN__CTFAIL(app_key, td, sptr,
			"%s: value not given (%s:%d)",
			td->name, __FILE__, __LINE__);
		return -1;
	}
	
	
	if(1 /* No applicable constraints whatsoever */) {
		/* Nothing is here. See below */
	}
	
	return td->check_constraints(td, sptr, ctfailcb, app_key);
}

static asn_per_constraints_t asn_PER_memb_extensionId_constr_2 GCC_NOTUSED = {
	{ APC_CONSTRAINED,	 8,  8,  0,  255 }	/* (0..255) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_value_constr_3 GCC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_extensionId_constr_5 GCC_NOTUSED = {
	{ APC_CONSTRAINED,	 8,  8,  0,  255 }	/* (0..255) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_value_constr_6 GCC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_extensionId_constr_8 GCC_NOTUSED = {
	{ APC_CONSTRAINED,	 8,  8,  0,  255 }	/* (0..255) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_value_constr_9 GCC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_extensionId_constr_11 GCC_NOTUSED = {
	{ APC_CONSTRAINED,	 8,  8,  0,  255 }	/* (0..255) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_per_constraints_t asn_PER_memb_value_constr_12 GCC_NOTUSED = {
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static asn_TYPE_member_t asn_MBR_Extension_22P0_1[] = {
	{ ATF_NOFLAGS, 0, offsetof(struct Extension_22P0, extensionId),
		(ASN_TAG_CLASS_UNIVERSAL | (2 << 2)),
		0,
		&asn_DEF_RefExt,
		memb_extensionId_constraint_1,
		&asn_PER_memb_extensionId_constr_2,
		0,
		"extensionId"
		},
	{ ATF_OPEN_TYPE | ATF_NOFLAGS, 0, offsetof(struct Extension_22P0, value),
		-1 /* Ambiguous tag (ANY?) */,
		0,
		&asn_DEF_ANY,
		memb_value_constraint_1,
		&asn_PER_memb_value_constr_3,
		0,
		"value"
		},
};
static const ber_tlv_tag_t asn_DEF_Extension_22P0_tags_1[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static const asn_TYPE_tag2member_t asn_MAP_Extension_22P0_tag2el_1[] = {
    { (ASN_TAG_CLASS_UNIVERSAL | (2 << 2)), 0, 0, 0 } /* extensionId */
};
static asn_SEQUENCE_specifics_t asn_SPC_Extension_22P0_specs_1 = {
	sizeof(struct Extension_22P0),
	offsetof(struct Extension_22P0, _asn_ctx),
	asn_MAP_Extension_22P0_tag2el_1,
	1,	/* Count of tags in the map */
	0, 0, 0,	/* Optional elements (not needed) */
	-1,	/* Start extensions */
	-1	/* Stop extensions */
};
asn_TYPE_descriptor_t asn_DEF_Extension_22P0 = {
	"Extension",
	"Extension",
	SEQUENCE_free,
	SEQUENCE_print,
	SEQUENCE_constraint,
	SEQUENCE_decode_ber,
	SEQUENCE_encode_der,
	SEQUENCE_decode_xer,
	SEQUENCE_encode_xer,
	SEQUENCE_decode_uper,
	SEQUENCE_encode_uper,
	0,	/* Use generic outmost tag fetcher */
	asn_DEF_Extension_22P0_tags_1,
	sizeof(asn_DEF_Extension_22P0_tags_1)
		/sizeof(asn_DEF_Extension_22P0_tags_1[0]), /* 1 */
	asn_DEF_Extension_22P0_tags_1,	/* Same as above */
	sizeof(asn_DEF_Extension_22P0_tags_1)
		/sizeof(asn_DEF_Extension_22P0_tags_1[0]), /* 1 */
	0,	/* No PER visible constraints */
	asn_MBR_Extension_22P0_1,
	2,	/* Elements count */
	&asn_SPC_Extension_22P0_specs_1	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_Extension_22P1_4[] = {
	{ ATF_NOFLAGS, 0, offsetof(struct Extension_22P1, extensionId),
		(ASN_TAG_CLASS_UNIVERSAL | (2 << 2)),
		0,
		&asn_DEF_RefExt,
		memb_extensionId_constraint_4,
		&asn_PER_memb_extensionId_constr_5,
		0,
		"extensionId"
		},
	{ ATF_OPEN_TYPE | ATF_NOFLAGS, 0, offsetof(struct Extension_22P1, value),
		-1 /* Ambiguous tag (ANY?) */,
		0,
		&asn_DEF_ANY,
		memb_value_constraint_4,
		&asn_PER_memb_value_constr_6,
		0,
		"value"
		},
};
static const ber_tlv_tag_t asn_DEF_Extension_22P1_tags_4[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static const asn_TYPE_tag2member_t asn_MAP_Extension_22P1_tag2el_4[] = {
    { (ASN_TAG_CLASS_UNIVERSAL | (2 << 2)), 0, 0, 0 } /* extensionId */
};
static asn_SEQUENCE_specifics_t asn_SPC_Extension_22P1_specs_4 = {
	sizeof(struct Extension_22P1),
	offsetof(struct Extension_22P1, _asn_ctx),
	asn_MAP_Extension_22P1_tag2el_4,
	1,	/* Count of tags in the map */
	0, 0, 0,	/* Optional elements (not needed) */
	-1,	/* Start extensions */
	-1	/* Stop extensions */
};
asn_TYPE_descriptor_t asn_DEF_Extension_22P1 = {
	"Extension",
	"Extension",
	SEQUENCE_free,
	SEQUENCE_print,
	SEQUENCE_constraint,
	SEQUENCE_decode_ber,
	SEQUENCE_encode_der,
	SEQUENCE_decode_xer,
	SEQUENCE_encode_xer,
	SEQUENCE_decode_uper,
	SEQUENCE_encode_uper,
	0,	/* Use generic outmost tag fetcher */
	asn_DEF_Extension_22P1_tags_4,
	sizeof(asn_DEF_Extension_22P1_tags_4)
		/sizeof(asn_DEF_Extension_22P1_tags_4[0]), /* 1 */
	asn_DEF_Extension_22P1_tags_4,	/* Same as above */
	sizeof(asn_DEF_Extension_22P1_tags_4)
		/sizeof(asn_DEF_Extension_22P1_tags_4[0]), /* 1 */
	0,	/* No PER visible constraints */
	asn_MBR_Extension_22P1_4,
	2,	/* Elements count */
	&asn_SPC_Extension_22P1_specs_4	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_Extension_22P2_7[] = {
	{ ATF_NOFLAGS, 0, offsetof(struct Extension_22P2, extensionId),
		(ASN_TAG_CLASS_UNIVERSAL | (2 << 2)),
		0,
		&asn_DEF_RefExt,
		memb_extensionId_constraint_7,
		&asn_PER_memb_extensionId_constr_8,
		0,
		"extensionId"
		},
	{ ATF_OPEN_TYPE | ATF_NOFLAGS, 0, offsetof(struct Extension_22P2, value),
		-1 /* Ambiguous tag (ANY?) */,
		0,
		&asn_DEF_ANY,
		memb_value_constraint_7,
		&asn_PER_memb_value_constr_9,
		0,
		"value"
		},
};
static const ber_tlv_tag_t asn_DEF_Extension_22P2_tags_7[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static const asn_TYPE_tag2member_t asn_MAP_Extension_22P2_tag2el_7[] = {
    { (ASN_TAG_CLASS_UNIVERSAL | (2 << 2)), 0, 0, 0 } /* extensionId */
};
static asn_SEQUENCE_specifics_t asn_SPC_Extension_22P2_specs_7 = {
	sizeof(struct Extension_22P2),
	offsetof(struct Extension_22P2, _asn_ctx),
	asn_MAP_Extension_22P2_tag2el_7,
	1,	/* Count of tags in the map */
	0, 0, 0,	/* Optional elements (not needed) */
	-1,	/* Start extensions */
	-1	/* Stop extensions */
};
asn_TYPE_descriptor_t asn_DEF_Extension_22P2 = {
	"Extension",
	"Extension",
	SEQUENCE_free,
	SEQUENCE_print,
	SEQUENCE_constraint,
	SEQUENCE_decode_ber,
	SEQUENCE_encode_der,
	SEQUENCE_decode_xer,
	SEQUENCE_encode_xer,
	SEQUENCE_decode_uper,
	SEQUENCE_encode_uper,
	0,	/* Use generic outmost tag fetcher */
	asn_DEF_Extension_22P2_tags_7,
	sizeof(asn_DEF_Extension_22P2_tags_7)
		/sizeof(asn_DEF_Extension_22P2_tags_7[0]), /* 1 */
	asn_DEF_Extension_22P2_tags_7,	/* Same as above */
	sizeof(asn_DEF_Extension_22P2_tags_7)
		/sizeof(asn_DEF_Extension_22P2_tags_7[0]), /* 1 */
	0,	/* No PER visible constraints */
	asn_MBR_Extension_22P2_7,
	2,	/* Elements count */
	&asn_SPC_Extension_22P2_specs_7	/* Additional specs */
};

static asn_TYPE_member_t asn_MBR_Extension_22P3_10[] = {
	{ ATF_NOFLAGS, 0, offsetof(struct Extension_22P3, extensionId),
		(ASN_TAG_CLASS_UNIVERSAL | (2 << 2)),
		0,
		&asn_DEF_RefExt,
		memb_extensionId_constraint_10,
		&asn_PER_memb_extensionId_constr_11,
		0,
		"extensionId"
		},
	{ ATF_OPEN_TYPE | ATF_NOFLAGS, 0, offsetof(struct Extension_22P3, value),
		-1 /* Ambiguous tag (ANY?) */,
		0,
		&asn_DEF_ANY,
		memb_value_constraint_10,
		&asn_PER_memb_value_constr_12,
		0,
		"value"
		},
};
static const ber_tlv_tag_t asn_DEF_Extension_22P3_tags_10[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (16 << 2))
};
static const asn_TYPE_tag2member_t asn_MAP_Extension_22P3_tag2el_10[] = {
    { (ASN_TAG_CLASS_UNIVERSAL | (2 << 2)), 0, 0, 0 } /* extensionId */
};
static asn_SEQUENCE_specifics_t asn_SPC_Extension_22P3_specs_10 = {
	sizeof(struct Extension_22P3),
	offsetof(struct Extension_22P3, _asn_ctx),
	asn_MAP_Extension_22P3_tag2el_10,
	1,	/* Count of tags in the map */
	0, 0, 0,	/* Optional elements (not needed) */
	-1,	/* Start extensions */
	-1	/* Stop extensions */
};
asn_TYPE_descriptor_t asn_DEF_Extension_22P3 = {
	"Extension",
	"Extension",
	SEQUENCE_free,
	SEQUENCE_print,
	SEQUENCE_constraint,
	SEQUENCE_decode_ber,
	SEQUENCE_encode_der,
	SEQUENCE_decode_xer,
	SEQUENCE_encode_xer,
	SEQUENCE_decode_uper,
	SEQUENCE_encode_uper,
	0,	/* Use generic outmost tag fetcher */
	asn_DEF_Extension_22P3_tags_10,
	sizeof(asn_DEF_Extension_22P3_tags_10)
		/sizeof(asn_DEF_Extension_22P3_tags_10[0]), /* 1 */
	asn_DEF_Extension_22P3_tags_10,	/* Same as above */
	sizeof(asn_DEF_Extension_22P3_tags_10)
		/sizeof(asn_DEF_Extension_22P3_tags_10[0]), /* 1 */
	0,	/* No PER visible constraints */
	asn_MBR_Extension_22P3_10,
	2,	/* Elements count */
	&asn_SPC_Extension_22P3_specs_10	/* Additional specs */
};

